#ifndef CUBEOBJECT_H
#define CUBEOBJECT_H

#include "shaderprogram.h"

#include <QOpenGLVertexArrayObject>
#include <QOpenGLBuffer>
#include <QVector3D>
#include <QOpenGLTexture>

//class QOpenGLShaderProgram;

class CubeObject
{
public:
    CubeObject();

    void create(ShaderProgram &shader);
    void render(ShaderProgram &shader);
    void destroy();

    QVector<QVector3D> cubePositions;

    QOpenGLVertexArrayObject m_vao; // Vertex array object
    QOpenGLBuffer            m_vbo; // Vertex buffer object
    QOpenGLBuffer            m_ebo; // Element buffer object

    //QOpenGLTexture        *texture1, *texture2;
    QOpenGLTexture        *texture1;
    QOpenGLTexture *textures[6] = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};
};

#endif // CUBEOBJECT_H
