#ifndef EXPLORETRIALSDIALOG_H
#define EXPLORETRIALSDIALOG_H

#include "checkboxheader.h"

#include <QDialog>
#include <QStandardItemModel>
#include <QSortFilterProxyModel>
#include <QAbstractButton>

typedef struct {
    int set;
    float cfom;
    int done;
    float rf;
} trialInfo;

namespace Ui {
class ExploreTrialsDialog;
}

class ExploreTrialsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ExploreTrialsDialog(QWidget *parent = nullptr);
    void setTrials(int kproc, int saf, int nset, int selset, trialInfo tInfo[]);
    ~ExploreTrialsDialog();

private slots:
    void on_buttonBox_clicked(QAbstractButton *button);
    void trialSelected(const QModelIndex &index);
    void rowCheckBoxClicked(const QModelIndex &index, bool state);
    void headerCheckBoxClicked(bool state);
    void on_exploreCheckBox_stateChanged(int arg1);

private:
    Ui::ExploreTrialsDialog *ui;
    QStandardItemModel *trialsModel;
    QSortFilterProxyModel *trialsProxyModel;
    CheckBoxHeader *cbHeader;

    void createTrialsModel();
    void fillTrialsModel(int ntrials, trialInfo tInfo[]);
    void updateTrialsModel(trialInfo tInfo[]);
    void setTrialsTableView();
    int rowCheckBoxClickedCount();
    int exploredTrialsCount();
};

#endif // EXPLORETRIALSDIALOG_H
