QT       += core gui network

QT       += printsupport

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets
greaterThan(QT_MAJOR_VERSION, 5): QT += openglwidgets

# uncomment the following line to use gfortran
# MYCOMPILER = gfortran
# uncomment the following line to use ifort
 MYCOMPILER = ifort
# uncomment the following line to use mpifort (gcc)
#MYCOMPILER = mpifort
# uncomment the following line to use mpiifort (intel)
#MYCOMPILER = mpiifort

TARGET = expo
TEMPLATE = app

#CONFIG += c++11
CONFIG += c++17

#avoid that the executable file is recognized as shared library
linux:{
       QMAKE_LFLAGS += -no-pie
}

# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x050F00    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    absrefdialog.cpp \
    backgroundcoefwidget.cpp \
    backgrounddialog.cpp \
    bondsettingsdialog.cpp \
    bondvalencedialog.cpp \
    bvpardialog.cpp \
    celllistdialog.cpp \
    cellparameterswidget.cpp \
    centroidsdlg.cpp \
    chainbutton.cpp \
    checkboxdelegate.cpp \
    checkboxheader.cpp \
    coddialog.cpp \
    colorbutton.cpp \
    colorwidget.cpp \
    commandline.cpp \
    correctionswidget.cpp \
    crystaldata.cpp \
    crystalstructurewidget.cpp \
    crystalsystemwidget.cpp \
    customplotzoom.cpp \
    directmethodsdialog.cpp \
    docdialog.cpp \
    dofwidget.cpp \
    doublespinboxdelegate.cpp \
    exploretrialsdialog.cpp \
    expoaboutdialog.cpp \
    exporttabledialog.cpp \
    fileutils.cpp \
    floatdelegate.cpp \
    formulaeditor.cpp \
    formulawidget.cpp \
    fourierdialog.cpp \
    fourierpeaklistdialog.cpp \
    geocalc.cpp \
    globaloptdialog.cpp \
    glutils.cpp \
    grafico.cpp \
    graphitem.cpp \
    hbondsoptionsdialog.cpp \
    highlighter.cpp \
    hkllistdialog.cpp \
    imgsettingsdialog.cpp \
    indexingdialog.cpp \
    infodialog.cpp \
    infotablewidget.cpp \
    itemdelegate.cpp \
    javwindow.cpp \
    json.cpp \
    libcomune.cpp \
    libfor.cpp \
    libmath.cpp \
    linestylescombobox.cpp \
    linestylewidget.cpp \
    locate.cpp \
    main.cpp \
    mainwindow.cpp \
    maps.cpp \
    marchingcubes.cpp \
    markerstylescombobox.cpp \
    markerstylewidget.cpp \
    minmaxdelegate.cpp \
    misc_expo.cpp \
    missinginfodialog.cpp \
    modelloader.cpp \
    models.cpp \
    mopacdialog.cpp \
    myfiledialog.cpp \
    myglwidget.cpp \
    myheader.cpp \
    mylistdialog.cpp \
    myproxymodel.cpp \
    myslider.cpp \
    networkdownload.cpp \
    nofocusdelegate.cpp \
    normhydrodlg.cpp \
    obutils.cpp \
    optionsdialog.cpp \
    overlayinfo.cpp \
    pairdist.cpp \
    pairdistsettings.cpp \
    peaklistwidget.cpp \
    peaksearchdialog.cpp \
    phasewidget.cpp \
    plotsettings.cpp \
    plotstyledialog.cpp \
    polyhedradialog.cpp \
    powderdatawidget.cpp \
    powderpattern.cpp \
    powderpatternsettings.cpp \
    preforientationwidget.cpp \
    profilefunctionwidget.cpp \
    properties.cpp \
    propertiesdialog.cpp \
    qcustomplot.cpp \
    qt_utils.cpp \
    qtdownload.cpp \
    rangedialog.cpp \
    renumberdialog.cpp \
    restraintsdialog.cpp \
    restraintswidget.cpp \
    rietvelddialog.cpp \
    savedialog.cpp \
    secondary.cpp \
    sequencedialog.cpp \
    sg_database.cpp \
    smoothingdialog.cpp \
    solutionsdialog.cpp \
    spacegdialog.cpp \
    spacegrouplistdialog.cpp \
    spacegroupwidget.cpp \
    spheredialog.cpp \
    stlutils.cpp \
    symmetrywidget.cpp \
    table.cpp \
    texteditor.cpp \
    transformdialog.cpp \
    wavedialog.cpp \
    wavelengthscombobox.cpp \
    wavelengthswidget.cpp \
    xpdutils.cpp

HEADERS += \
    absrefdialog.h \
    aligndelegate.h \
    backgroundcoefwidget.h \
    backgrounddialog.h \
    bondsettingsdialog.h \
    bondvalencedialog.h \
    bvpardialog.h \
    celllistdialog.h \
    cellparameterswidget.h \
    centroidsdlg.h \
    chainbutton.h \
    checkboxdelegate.h \
    checkboxheader.h \
    coddialog.h \
    colorbutton.h \
    colorwidget.h \
    commandline.h \
    config_any.h \
    correctionswidget.h \
    crystaldata.h \
    crystalstructurewidget.h \
    crystalsystemwidget.h \
    customplotzoom.h \
    dataset.h \
    directives.h \
    directmethodsdialog.h \
    docdialog.h \
    dofwidget.h \
    doublespinboxdelegate.h \
    exploretrialsdialog.h \
    expoaboutdialog.h \
    expokeysettings.h \
    exporttabledialog.h \
    fileutils.h \
    filtri.h \
    floatdelegate.h \
    formulaeditor.h \
    formulawidget.h \
    fourierdialog.h \
    fourierpeaklistdialog.h \
    geocalc.h \
    globaloptdialog.h \
    glutils.h \
    grafico.h \
    graphitem.h \
    hbondsoptionsdialog.h \
    highlighter.h \
    hkllistdialog.h \
    imgsettingsdialog.h \
    indexingdialog.h \
    infodialog.h \
    infotablewidget.h \
    itemdelegate.h \
    javkeysettings.h \
    javwindow.h \
    json.h \
    libcomune.h \
    libmath.h \
    libmatrix.h \
    libvector.h \
    linestylescombobox.h \
    linestylewidget.h \
    lookuptable.h \
    mainwindow.h \
    maps.h \
    marchingcubes.h \
    markerstylescombobox.h \
    markerstylewidget.h \
    minmaxdelegate.h \
    missinginfodialog.h \
    modelloader.h \
    models.h \
    mopacdialog.h \
    myfiledialog.h \
    myglwidget.h \
    myheader.h \
    mylistdialog.h \
    myproxymodel.h \
    myslider.h \
    networkdownload.h \
    nofocusdelegate.h \
    normhydrodlg.h \
    nr.h \
    optionsdialog.h \
    overlayinfo.h \
    pairdist.h \
    pairdistsettings.h \
    peaklistwidget.h \
    peaksearchdialog.h \
    phasewidget.h \
    plotsettings.h \
    plotstyledialog.h \
    polyhedradialog.h \
    powderdatawidget.h \
    powderpattern.h \
    powderpatternsettings.h \
    preforientationwidget.h \
    profilefunctionwidget.h \
    properties.h \
    propertiesdialog.h \
    qcustomplot.h \
    qt_utils.h \
    qtdownload.h \
    rangedialog.h \
    renumberdialog.h \
    restraintsdialog.h \
    restraintswidget.h \
    rietvelddialog.h \
    savedialog.h \
    sequencedialog.h \
    sg_database.h \
    smoothingdialog.h \
    solutionsdialog.h \
    spacegdialog.h \
    spacegrouplistdialog.h \
    spacegroupwidget.h \
    spheredialog.h \
    stlutils.h \
    symmetrywidget.h \
    table.h \
    texteditor.h \
    transformdialog.h \
    wavedialog.h \
    wavelengthscombobox.h \
    wavelengthswidget.h \
    xpdutils.h

FORMS += \
    absrefdialog.ui \
    backgroundcoefwidget.ui \
    backgrounddialog.ui \
    bondsettingsdialog.ui \
    bondvalencedialog.ui \
    bvpardialog.ui \
    celllistdialog.ui \
    cellparameterswidget.ui \
    centroidsdlg.ui \
    chainbutton.ui \
    coddialog.ui \
    colorwidget.ui \
    correctionswidget.ui \
    crystalstructurewidget.ui \
    crystalsystemwidget.ui \
    directmethodsdialog.ui \
    docdialog.ui \
    dofwidget.ui \
    exploretrialsdialog.ui \
    expoaboutdialog.ui \
    exporttabledialog.ui \
    formulawidget.ui \
    fourierdialog.ui \
    fourierpeaklistdialog.ui \
    geocalc.ui \
    globaloptdialog.ui \
    hbondsoptionsdialog.ui \
    hkllistdialog.ui \
    imgsettingsdialog.ui \
    indexingdialog.ui \
    infodialog.ui \
    javwindow.ui \
    linestylewidget.ui \
    mainwindow.ui \
    markerstylewidget.ui \
    missinginfodialog.ui \
    modelloader.ui \
    mopacdialog.ui \
    mylistdialog.ui \
    normhydrodlg.ui \
    optionsdialog.ui \
    overlayinfo.ui \
    pairdist.ui \
    pairdistsettings.ui \
    peaklistwidget.ui \
    peaksearchdialog.ui \
    phasewidget.ui \
    plotstyledialog.ui \
    polyhedradialog.ui \
    powderdatawidget.ui \
    powderpattern.ui \
    powderpatternsettings.ui \
    preforientationwidget.ui \
    profilefunctionwidget.ui \
    propertiesdialog.ui \
    rangedialog.ui \
    renumberdialog.ui \
    restraintsdialog.ui \
    restraintswidget.ui \
    rietvelddialog.ui \
    sequencedialog.ui \
    smoothingdialog.ui \
    solutionsdialog.ui \
    spacegdialog.ui \
    spacegrouplistdialog.ui \
    spacegroupwidget.ui \
    spheredialog.ui \
    symmetrywidget.ui \
    table.ui \
    texteditor.ui \
    transformdialog.ui \
    wavedialog.ui \
    wavelengthswidget.ui

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

RESOURCES += \
    resource.qrc

DEFINES += APP_NAME=\\\"expo\\\"
VERSION = 2.0.0
DEFINES += APP_VERSION=\\\"$$VERSION\\\"

FORTRAN_SOURCES += \
progtype.f90 \
prog_names.f90 \
constants.f90 \
recipes.f90 \
arrayutil.f90 \
strutil.f90 \
timer.f90 \
math_util.f90 \
error.f90 \
mpi_util.f90 \
fileutil.f90 \
elements.f90 \
atombasic.f90 \
fract.f90 \
symm_table.f90 \
spginfo.f90 \
moduli.f \
smooth.f90 \
unit_cell.f90 \
stat.f90 \
utiln.f90 \
qtutil.f90 \
pfunction.f90 \
counts.f90 \
bond2014.f90 \
winlist.f90 \
cgeom.f90 \
nl2sol.f90 \
lsqnew.f90 \
marquardt.f90 \
genlsq.f90 \
peakutil.f90 \
background.f90 \
bondsutil.f90 \
kspecmod.f90 \
atomsutil.f90 \
fragments.f90 \
molpnew.f90 \
molgraph.f90 \
pdf.f90 \
abscorr.f90 \
reflectionsutil.f90 \
modeltype.f90 \
centroids.f90 \
asymfunc.f90 \
psvoigtfunc.f90 \
mmpsi.f \
pearsonfunc.f90 \
tchzfunc.f90 \
gamess_form.f90 \
nwchem_form.f90 \
abinit_form.f90 \
crystal_form.f90 \
povray_form.f90 \
qe_form.f90 \
contacts.f90 \
restraints.f90 \
bvalence.f90 \
bump.f90 \
goptutil.f90 \
plotstyle.f90 \
mapinfo.f90 \
rigidb.f90 \
constraints.f90 \
symmgrid.f90 \
sphase.f90 \
hydrogens.f90 \
pdb_form.f90 \
shelx_form.f90 \
fra_form.f90 \
zmt_form.f90 \
xyz_form.f90 \
mol2_form.f90 \
mop_form.f90 \
dataset.f90 \
calcpdp.f90 \
cif_form.f90 \
filetype.f90 \
variables.f90 \
expointerface.f90 \
chem_files.f90 \
quant.f90 \
sinterface.f90 \
cryutil.f90 \
messages.f90 \
grexpo.f90 \
spacec.f90 \
rietmodule.f90 \
vedi2005.f90 \
commands.f90 \
madsad_pow.f \
symmutils.f \
polyhedra.f90 \
randomstaff.f90 \
randomgroupstaff.f90 \
pirum.f \
chain.f \
invfour.f \
statistic.f \
invar.f \
screen2.f90 \
obmodule.f90 \
gen_form.f90 \
datautil.f90 \
indexing.f90 \
inputfile.f90 \
data2013.f90 \
spgext.f90 \
extra.f \
defspace.f90 \
data.f \
refana.f \
zmatrix.f \
ntreor.f \
norm.f \
fourier.f90 \
list2006.f \
listaexpo.f \
patter.f \
edm.f \
build.f \
build_new.f90 \
test2006.f \
blas.f \
prefour.f \
util.f \
javinterface_expo.f90 \
exportexpon.f90 \
javcomune.f90 \
drawatoms.f90 \
screen.f \
poly.f \
restart.f90 \
phase.f \
directn.f90 \
expand.f \
setref.f90 \
rietveld.f90 \
rinterface.f90 \
expo_empty.f90 \
molp.f \
fmaps.f90 \
four.f \
simann.f90 \
bb_bc.f90 \
cfunction.f90 \
sannel.f90 \
fsrefine.f90 \
peso.f \
diretto.f \
project.f90 \
expo2015.f90 \
patt2006.f \
expo.f \
interop.f90 \
specif.f

win32-msvc: {
   ifort.output = ${QMAKE_FILE_BASE}.obj
   CONFIG( debug, debug|release )  {
      contains(QT_ARCH, i386) {
          ifort.commands = "$$(IFORT_COMPILER19)\bin\intel64_ia32\ifort" ${QMAKE_FILE_NAME} -c -fpp /Od /debug:full /names:lowercase /assume:underscore  /libs:dll /threads /dbglibs
      } else: {
          ifort.commands = "$$(IFORT_COMPILER19)\bin\intel64\ifort" ${QMAKE_FILE_NAME} -c -fpp /Od /debug:full /names:lowercase /assume:underscore  /libs:dll /threads /dbglibs
      }
   }
   CONFIG( release, release|debug )  {
      contains(QT_ARCH, i386) {
      ifort.commands = "$$(IFORT_COMPILER19)\bin\intel64_ia32\ifort" ${QMAKE_FILE_NAME} -c -fpp /names:lowercase /assume:underscore  /libs:dll /threads
      } else: {
      ifort.commands = "$$(IFORT_COMPILER19)\bin\intel64\ifort" ${QMAKE_FILE_NAME} -c -fpp /names:lowercase /assume:underscore  /libs:dll /threads
      }
   }
} else:  {
    DESTDIR = $$PWD/../build_$$MYCOMPILER
    CONFIG( debug, debug|release )  {
       DESTDIR = $$join(DESTDIR,,,_debug)
       #add -warn all only for *.f90
       ifort.commands = ifort ${QMAKE_FILE_NAME} -c -check all -check noarg_temp_created -fpp -fPIC -traceback -g -o $$DESTDIR/${QMAKE_FILE_BASE}.o -module $$DESTDIR
       gfortran.commands = gfortran ${QMAKE_FILE_NAME} -c -cpp -fPIC -Wall -fbounds-check -g -J $$DESTDIR -o $$DESTDIR/${QMAKE_FILE_BASE}.o
       mpifort.commands = mpifort ${QMAKE_FILE_NAME} -c -cpp -fPIC -Wall -fbounds-check -g -DMPI -J $$DESTDIR -o $$DESTDIR/${QMAKE_FILE_BASE}.o
       mpiifort.commands = mpiifort ${QMAKE_FILE_NAME} -c -check all -check noarg_temp_created -fpp -DMPI -fPIC -traceback -g -o $$DESTDIR/${QMAKE_FILE_BASE}.o -module $$DESTDIR
    }
    CONFIG( release, release|debug )  {
       DESTDIR = $$join(DESTDIR,,,_release)
       ifort.commands = ifort ${QMAKE_FILE_NAME} -c -O2 -fpp -fPIC -o $$DESTDIR/${QMAKE_FILE_BASE}.o -module $$DESTDIR
       gfortran.commands = gfortran ${QMAKE_FILE_NAME} -c -O2 -cpp -fPIC -J $$DESTDIR -o $$DESTDIR/${QMAKE_FILE_BASE}.o
       mpifort.commands = mpifort ${QMAKE_FILE_NAME} -c -O2 -cpp -fPIC -fopenmp -DMPI -J $$DESTDIR -o $$DESTDIR/${QMAKE_FILE_BASE}.o
       mpiifort.commands = mpiifort ${QMAKE_FILE_NAME} -c -O2 -fpp -DMPI -fPIC -o $$DESTDIR/${QMAKE_FILE_BASE}.o -module $$DESTDIR
    }
    ifort.output = $$DESTDIR/${QMAKE_FILE_BASE}.o
    gfortran.output = $$DESTDIR/${QMAKE_FILE_BASE}.o
    mpifort.output = $$DESTDIR/${QMAKE_FILE_BASE}.o
    mpiifort.output = $$DESTDIR/${QMAKE_FILE_BASE}.o
    OBJECTS_DIR = $$DESTDIR
    MOC_DIR = $$DESTDIR
    RCC_DIR = $$DESTDIR
    UI_DIR = $$DESTDIR

#   Copy extra files for indexing
    copydata.commands = $(COPY_DIR) $$PWD/../indexing/* $$DESTDIR
    first.depends = $(first) copydata
    export(first.depends)
    export(copydata.commands)
    QMAKE_EXTRA_TARGETS += first copydata
}
ifort.input = FORTRAN_SOURCES
gfortran.input = FORTRAN_SOURCES
mpifort.input = FORTRAN_SOURCES
mpiifort.input = FORTRAN_SOURCES

QMAKE_EXTRA_COMPILERS += $${MYCOMPILER}

unix: {
extraclean.commands = find $$DESTDIR -name \"*.mod\" -exec rm -v {} \\;
clean.depends = extraclean
QMAKE_EXTRA_TARGETS += clean extraclean
}
DISTFILES += $$FORTRAN_SOURCES
#for(a,DISTFILES):message($${a})

OBVER = $$system(pkg-config --exists openbabel-2.0; echo $?)
contains( OBVER, 1 ) : PKGCONFIG += openbabel-3
else: PKGCONFIG += openbabel-2.0
#packagesExist(openbabel-2.0) : PKGCONFIG += openbabel-2.0
#else: PKGCONFIG += openbabel-3

CONFIG += link_pkgconfig
win32: {
#      INCLUDEPATH += "$$PWD\include\openbabel-2.0"
      INCLUDEPATH += "$$PWD\include\openbabel3"
      CONFIG( debug, debug|release )  {
           contains(QT_ARCH, i386) {
#               LIBS+= -L"$$PWD\lib32" -lopenbabel-2d -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\ia32_win
               LIBS+= -L"$$PWD\lib32" -lopenbabel-3d -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\ia32_win
           } else {
#               LIBS+= -L"$$PWD\lib" -lopenbabel-2d -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\intel64_win
               LIBS+= -L"$$PWD\lib" -lopenbabel-3d -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\intel64_win
           }
           QMAKE_CFLAGS +=  /MDd
           QMAKE_LFLAGS +=  /NODEFAULTLIB:libcmtd
           QMAKE_LFLAGS += /STACK:"60000000"
      }
      CONFIG( release, debug|release )  {
           contains(QT_ARCH, i386) {
#               LIBS+= -L"$$PWD\lib32" -lopenbabel-2 -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\ia32_win
               LIBS+= -L"$$PWD\lib32" -lopenbabel-3 -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\ia32_win
           } else {
#               LIBS+= -L"$$PWD\lib" -lopenbabel-2 -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\intel64_win
               LIBS+= -L"$$PWD\lib" -lopenbabel-3 -lopengl32 -L$$(IFORT_COMPILER19)\compiler\lib\intel64_win
           }
           QMAKE_CFLAGS += /MD
           QMAKE_LFLAGS += /NODEFAULTLIB:libcmt
           QMAKE_LFLAGS += /STACK:"60000000"
      }
}else: {
    equals(MYCOMPILER, "ifort")   {
          LIBS += -lifport -lifcore -limf -lsvml -lintlc
    }
    equals(MYCOMPILER, "gfortran")    {
          LIBS += -lgfortran
    }
    equals(MYCOMPILER, "mpifort")    {
          LIBS += -lgfortran -lgomp
          LIBS += $$system(mpifort --showme:link)
    }
    equals(MYCOMPILER, "mpiifort")   {
          LIBS += -lifport -lifcore -limf -lsvml -lintlc
          LIBS += -lmpifort
    }
       }

