#ifndef HBONDSOPTIONSDIALOG_H
#define HBONDSOPTIONSDIALOG_H

#include <QDialog>
#include <QAbstractButton>

typedef struct {
                int z;
                int active;
               }_ContactType;
typedef struct {
                float tolmin, tolmax;
                int   hpresent, inter, intra, nminbond, hangat;
               } _ContactOptionType;

namespace Ui {
class HBondsOptionsDialog;
}

class HBondsOptionsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit HBondsOptionsDialog(QWidget *parent = nullptr);
    ~HBondsOptionsDialog();
    void SaveHBoptions();

private slots:
    void on_buttonBox_clicked(QAbstractButton *button);    
    void reject();

private:
    Ui::HBondsOptionsDialog *ui;
    int nDonors, nAcceptors;
    _ContactType *donor0, *acceptor0;
    _ContactOptionType HBopt0;
    _ContactType *donorSave, *acceptorSave;
    _ContactOptionType HBoptSave;
    void get_values_for_HBOpt(_ContactType d[], _ContactType a[],
                              _ContactOptionType& opt);
    void set_values_for_HBOpt(const _ContactType d[], const _ContactType a[],
                              const _ContactOptionType& opt);
    void RestoreHBoptions();        
};

#endif // HBONDSOPTIONSDIALOG_H
