#ifndef INTERVALSDIALOG_H
#define INTERVALSDIALOG_H

#include <QDialog>
#include <QAbstractButton>

class CustomPlotZoom;

namespace Ui {
class IntervalsDialog;
}

class IntervalsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit IntervalsDialog(QWidget *parent = nullptr);
    void setIntervals(CustomPlotZoom *plot);
    ~IntervalsDialog();

private slots:
    void intervalSelected(int index);
    void buttonBoxClicked(QAbstractButton *button);
    void minSpinBoxChanged(double value);
    void maxSpinBoxChanged(double value);
    void lcursorPositionChanged(double pos);
    void rcursorPositionChanged(double pos);
    void reject() override;

private:
    Ui::IntervalsDialog *ui;
    QVector<float> minVal, maxVal;
    bool intervalsChanged;
    bool moveCursor;
    CustomPlotZoom *mPlot;
    void setCloseDialog();
};

#endif // INTERVALSDIALOG_H
