#ifndef MAPS_H
#define MAPS_H
#define MAPS 1
#include "marchingcubes.h"
#include "libmatrix.h"
#include <QColor>
#include <QString>
#include  <QtGui/QOpenGLFunctions>

class Mappa {
public:
      Mappa();
      void SetColor(int ind, bool if_surface=false);
      void FillMap(int np[], float ***mappa, int ***color,
        float denmin=0,float denmax=0,
        float avden=0,float stden=0);
      void run_mc(int limx, int limy, int limz);
      void CalcolaC();
      void freeMap();
      void RunMC();
      void DrawMap(QOpenGLFunctions *f);
      void DrawCube();
      void FromRadTorad();
      void fromTrianglesToVertices(GLdouble *vertices, GLdouble *normals);
      double SigmaMappa();
      double minimum;
      double maximum;
      double mean;
      bool ifVis;
      vet3 vn[8];          // vertici cubo spigolo 2*R e centro xyzC
      vet3 vf[8];          // vertici cubo spigolo 2*R e centro xyzC
      vet3 vmN[8];
      vet3 vnN;
      QColor color_mappa;
      float  iso;
      int   size_x;
      int   size_y;
      int   size_z;
      int   size_m;
      int   size_M;
      int   cx;
      int   cy;
      int   cz;
      int   radius_x;
      int   radius_y;
      int   radius_z;
      int   wireframe;
      float  sigma;
      float xmin[3];
      float xmax[3];
      float  sigmaMax;
      int   nsym;
      float resm;
      int nrefl;
      int   ifDifference;
      bool created;
      bool isSurface;
      bool multicolor;
      float radius;
      float step;
      QString name;
      float  *mappa;
      int     *color;
      MarchingCubes *mc ;
};
     //void on_sigma(GtkWidget *button, gpointer data);
     //void centre_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vboxx,
     //                     bool block_h = false);
     //void set_values_for_centre(GtkWidget *father, GtkWidget *window);
     //void map_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vbox,
     //                     bool block_h = false);
     //void update_maps(GtkWidget *father, GtkWidget *window);
     //void set_values_for_map(int i, GtkWidget *father, GtkWidget *window);
     //void PrintMapInfo(gpointer,  gpointer data);
extern "C" float getxmap_(int *i, int *j, int *k);
#endif
