#include "mylistdialog.h"
#include "ui_mylistdialog.h"

#include <QStringListModel>

MyListDialog::MyListDialog(const QStringList &list, const QString &title, const QString &listTitle, int selected, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::myListDialog)
{
    ui->setupUi(this);

    model = new QStringListModel(this);
    model->setStringList(list);

    ui->listView->setModel(model);
    QModelIndex index = model->index(selected, 0);
    if (index.isValid()) ui->listView->setCurrentIndex(index);

    ui->label->setText(listTitle);
    setWindowTitle(title);
}

int MyListDialog::currentIndex()
{
    return ui->listView->currentIndex().row();
}

MyListDialog::~MyListDialog()
{
    delete ui;
}
