//
// Class built from the example: https://doc.qt.io/qt-5/qtnetwork-download-example.html
// downloadmanager.h contains a more complex class from: https://doc.qt.io/qt-5/qtnetwork-downloadmanager-example.html
//
#ifndef NETWORKDOWNLOAD_H
#define NETWORKDOWNLOAD_H

#include <QFile>
#include <QFileInfo>
#include <QList>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QSslError>
#include <QStringList>
#include <QUrl>
#include <stdio.h>


class QSslError;

class NetworkDownload: public QObject
{
    Q_OBJECT

public:
    explicit NetworkDownload(QObject *parent = nullptr);
    void doDownload(const QUrl &url);
    QString saveFileName(const QUrl &url);
    bool saveToDisk(const QString &filename, QIODevice *data);
    void setDownloadFolder(const QString &value);

signals:
    void downloadCompleted(bool success, const QString &filename);

public slots:
    void execute(const QStringList &args);
    void downloadFinished(QNetworkReply *reply);
    void sslErrors(const QList<QSslError> &errors);

private:
    QNetworkAccessManager manager;
    QList<QNetworkReply *> currentDownloads;
    QString downloadFolder;
};


#endif // NETWORKDOWNLOAD_H
