! ----------------------------------------------------------------------
   module util_interop

   implicit none

   contains

   integer function home_location(hfolder)
!
!  Return the home directory. This is equal to $HOME on linux
!
   use iso_c_binding
   use strutil

   interface
   function HomeLocationC(dirnam,lend) bind(C,name="HomeLocationC")
   use iso_c_binding
   character(c_char), dimension(*) :: dirnam
   integer(c_int)                  :: lend
   integer(c_int)                  :: HomeLocationC
   end function HomeLocationC
   end interface
!
   integer get_configdir
   character(len=:), allocatable, intent(out) :: hfolder
   character(c_char), dimension(256)          :: hfolder1
   integer                                    :: lend
!
   home_location = HomeLocationC(hfolder1,lend)
   hfolder = toFortranString(hfolder1,lend)
!
   end function home_location

!--------------------------------------------------------------------

   subroutine set_current_files(fileIn,fileOut,fileType)
!
!  Set name of input and output file for GUI
!
   use strutil
   interface
      subroutine setCurrentFiles(c_fileIn, c_fileOut, c_fileType) bind(C,name="setCurrentFiles")
      use iso_c_binding
      character(c_char) :: c_fileIn(*), c_fileOut(*), c_fileType
      end subroutine setCurrentFiles
   end interface
   character(len=*), intent(in) :: fileIn, fileOut, fileType

   call setCurrentFiles(f_to_c(fileIn),f_to_c(fileOut),f_to_c(fileType))

   end subroutine set_current_files

!--------------------------------------------------------------------

   function get_program_directory() result(dir)
!
!  Return the application directory path
!
   use iso_c_binding
   use strutil

   interface
      subroutine getProgramDir(dirnam,lend) bind(C,name="getProgramDir")
      use iso_c_binding
      character(c_char) :: dirnam(*)
      integer(c_int)    :: lend
      end subroutine getProgramDir
   end interface

   character(len=:), allocatable     :: dir
   character(c_char), dimension(256) :: dir1
   integer(c_int)                    :: lend

   call getProgramDir(dir1,lend)
   dir = toFortranString(dir1,lend)

   end function get_program_directory

   end module
