#include "restraintstargetdialog.h"
#include "ui_restraintstargetdialog.h"

RestraintsTargetDialog::RestraintsTargetDialog(crydata::targetType targetValue, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::RestraintsTargetDialog)
{
    ui->setupUi(this);

    switch (targetValue) {
    case crydata::TARG_BOND_TABLE:
        ui->radioButton_1->setChecked(true);
        break;
    case crydata::TARG_CURRENT:
        ui->radioButton_2->setChecked(true);
        break;
    case crydata::TARG_MOL_MEC:
        ui->radioButton_3->setChecked(true);
        break;
    }
}

crydata::targetType RestraintsTargetDialog::getTargetType()
{    
    if (ui->radioButton_2->isChecked()) return crydata::TARG_CURRENT;
    if (ui->radioButton_3->isChecked()) return crydata::TARG_MOL_MEC;

    return crydata::TARG_BOND_TABLE;
}

RestraintsTargetDialog::~RestraintsTargetDialog()
{
    delete ui;
}
