#ifndef SEQUENCEDIALOG_H
#define SEQUENCEDIALOG_H

#include <QDialog>
#include <QTextStream>
#include <QLabel>
#include <QVBoxLayout>

#include "models.h"

namespace Ui {
class SequenceDialog;
}

class SequenceDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SequenceDialog(QWidget *parent = nullptr, Model *md=nullptr);
    ~SequenceDialog();
    void FillSequence(bool ifOther);

private:
    Ui::SequenceDialog *ui;
    QTextStream m_Sequence;
    //QLayout * m_layout;
    QVBoxLayout * m_layout;
    Model *md;
    void exportFasta(QFile &f);
    void exportPir(QFile &f);

private slots:
    void on_closeButton_clicked();
    void on_exportButton_clicked();
    void on_checkBoxNotAmino_toggled(bool checked);
    void goToResidue(int katom=0);
};

#endif // SEQUENCEDIALOG_H
