#ifndef SOLUTIONSDIALOG_H
#define SOLUTIONSDIALOG_H

#include <QDialog>
#include <QStandardItemModel>
#include <QSortFilterProxyModel>
#include <QAbstractButton>

typedef struct {
    int run;
    float cf;
} SolutionInfo;

namespace Ui {
class SolutionsDialog;
}

class SolutionsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SolutionsDialog(QWidget *parent = nullptr);
    ~SolutionsDialog();
    void setDialog(int &nsol, int nexport);
    void resetLastSelection();

private slots:
    void on_buttonBox_clicked(QAbstractButton *button);

private:
    Ui::SolutionsDialog *ui;
    QStandardItemModel *solutionModel;
    QSortFilterProxyModel *solutionProxyModel;
    int lastSelection;
    int savedSelection;

    void createSolutionModel();
    void setSolutionTableView();
};

#endif // SOLUTIONSDIALOG_H
